// Unless explicitly stated otherwise all files in this repository are licensed
// under the Apache License Version 2.0.
// This product includes software developed at Datadog (https://www.datadoghq.com/).
// Copyright 2016-2019 Datadog, Inc.

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"time"

	v1alpha1 "github.com/DataDog/datadog-operator/pkg/apis/datadoghq/v1alpha1"
	scheme "github.com/DataDog/datadog-operator/pkg/generated/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// DatadogAgentsGetter has a method to return a DatadogAgentInterface.
// A group's client should implement this interface.
type DatadogAgentsGetter interface {
	DatadogAgents(namespace string) DatadogAgentInterface
}

// DatadogAgentInterface has methods to work with DatadogAgent resources.
type DatadogAgentInterface interface {
	Create(*v1alpha1.DatadogAgent) (*v1alpha1.DatadogAgent, error)
	Update(*v1alpha1.DatadogAgent) (*v1alpha1.DatadogAgent, error)
	UpdateStatus(*v1alpha1.DatadogAgent) (*v1alpha1.DatadogAgent, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.DatadogAgent, error)
	List(opts v1.ListOptions) (*v1alpha1.DatadogAgentList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.DatadogAgent, err error)
	DatadogAgentExpansion
}

// datadogAgents implements DatadogAgentInterface
type datadogAgents struct {
	client rest.Interface
	ns     string
}

// newDatadogAgents returns a DatadogAgents
func newDatadogAgents(c *DatadoghqV1alpha1Client, namespace string) *datadogAgents {
	return &datadogAgents{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the datadogAgent, and returns the corresponding datadogAgent object, and an error if there is any.
func (c *datadogAgents) Get(name string, options v1.GetOptions) (result *v1alpha1.DatadogAgent, err error) {
	result = &v1alpha1.DatadogAgent{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("datadogagents").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of DatadogAgents that match those selectors.
func (c *datadogAgents) List(opts v1.ListOptions) (result *v1alpha1.DatadogAgentList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.DatadogAgentList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("datadogagents").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested datadogAgents.
func (c *datadogAgents) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("datadogagents").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a datadogAgent and creates it.  Returns the server's representation of the datadogAgent, and an error, if there is any.
func (c *datadogAgents) Create(datadogAgent *v1alpha1.DatadogAgent) (result *v1alpha1.DatadogAgent, err error) {
	result = &v1alpha1.DatadogAgent{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("datadogagents").
		Body(datadogAgent).
		Do().
		Into(result)
	return
}

// Update takes the representation of a datadogAgent and updates it. Returns the server's representation of the datadogAgent, and an error, if there is any.
func (c *datadogAgents) Update(datadogAgent *v1alpha1.DatadogAgent) (result *v1alpha1.DatadogAgent, err error) {
	result = &v1alpha1.DatadogAgent{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("datadogagents").
		Name(datadogAgent.Name).
		Body(datadogAgent).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *datadogAgents) UpdateStatus(datadogAgent *v1alpha1.DatadogAgent) (result *v1alpha1.DatadogAgent, err error) {
	result = &v1alpha1.DatadogAgent{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("datadogagents").
		Name(datadogAgent.Name).
		SubResource("status").
		Body(datadogAgent).
		Do().
		Into(result)
	return
}

// Delete takes name of the datadogAgent and deletes it. Returns an error if one occurs.
func (c *datadogAgents) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("datadogagents").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *datadogAgents) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("datadogagents").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched datadogAgent.
func (c *datadogAgents) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.DatadogAgent, err error) {
	result = &v1alpha1.DatadogAgent{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("datadogagents").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
