// Unless explicitly stated otherwise all files in this repository are licensed
// under the Apache License Version 2.0.
// This product includes software developed at Datadog (https://www.datadoghq.com/).
// Copyright 2016-2019 Datadog, Inc.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1alpha1 "github.com/DataDog/datadog-operator/pkg/apis/datadoghq/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeDatadogAgents implements DatadogAgentInterface
type FakeDatadogAgents struct {
	Fake *FakeDatadoghqV1alpha1
	ns   string
}

var datadogagentsResource = schema.GroupVersionResource{Group: "datadoghq.com", Version: "v1alpha1", Resource: "datadogagents"}

var datadogagentsKind = schema.GroupVersionKind{Group: "datadoghq.com", Version: "v1alpha1", Kind: "DatadogAgent"}

// Get takes name of the datadogAgent, and returns the corresponding datadogAgent object, and an error if there is any.
func (c *FakeDatadogAgents) Get(name string, options v1.GetOptions) (result *v1alpha1.DatadogAgent, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(datadogagentsResource, c.ns, name), &v1alpha1.DatadogAgent{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DatadogAgent), err
}

// List takes label and field selectors, and returns the list of DatadogAgents that match those selectors.
func (c *FakeDatadogAgents) List(opts v1.ListOptions) (result *v1alpha1.DatadogAgentList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(datadogagentsResource, datadogagentsKind, c.ns, opts), &v1alpha1.DatadogAgentList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.DatadogAgentList{ListMeta: obj.(*v1alpha1.DatadogAgentList).ListMeta}
	for _, item := range obj.(*v1alpha1.DatadogAgentList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested datadogAgents.
func (c *FakeDatadogAgents) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(datadogagentsResource, c.ns, opts))

}

// Create takes the representation of a datadogAgent and creates it.  Returns the server's representation of the datadogAgent, and an error, if there is any.
func (c *FakeDatadogAgents) Create(datadogAgent *v1alpha1.DatadogAgent) (result *v1alpha1.DatadogAgent, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(datadogagentsResource, c.ns, datadogAgent), &v1alpha1.DatadogAgent{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DatadogAgent), err
}

// Update takes the representation of a datadogAgent and updates it. Returns the server's representation of the datadogAgent, and an error, if there is any.
func (c *FakeDatadogAgents) Update(datadogAgent *v1alpha1.DatadogAgent) (result *v1alpha1.DatadogAgent, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(datadogagentsResource, c.ns, datadogAgent), &v1alpha1.DatadogAgent{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DatadogAgent), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeDatadogAgents) UpdateStatus(datadogAgent *v1alpha1.DatadogAgent) (*v1alpha1.DatadogAgent, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(datadogagentsResource, "status", c.ns, datadogAgent), &v1alpha1.DatadogAgent{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DatadogAgent), err
}

// Delete takes name of the datadogAgent and deletes it. Returns an error if one occurs.
func (c *FakeDatadogAgents) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(datadogagentsResource, c.ns, name), &v1alpha1.DatadogAgent{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeDatadogAgents) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(datadogagentsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha1.DatadogAgentList{})
	return err
}

// Patch applies the patch and returns the patched datadogAgent.
func (c *FakeDatadogAgents) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.DatadogAgent, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(datadogagentsResource, c.ns, name, pt, data, subresources...), &v1alpha1.DatadogAgent{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DatadogAgent), err
}
