// Unless explicitly stated otherwise all files in this repository are licensed
// under the Apache License Version 2.0.
// This product includes software developed at Datadog (https://www.datadoghq.com/).
// Copyright 2016-2019 Datadog, Inc.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1alpha1 "github.com/DataDog/datadog-operator/pkg/apis/datadoghq/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeDatadogMetrics implements DatadogMetricInterface
type FakeDatadogMetrics struct {
	Fake *FakeDatadoghqV1alpha1
	ns   string
}

var datadogmetricsResource = schema.GroupVersionResource{Group: "datadoghq.com", Version: "v1alpha1", Resource: "datadogmetrics"}

var datadogmetricsKind = schema.GroupVersionKind{Group: "datadoghq.com", Version: "v1alpha1", Kind: "DatadogMetric"}

// Get takes name of the datadogMetric, and returns the corresponding datadogMetric object, and an error if there is any.
func (c *FakeDatadogMetrics) Get(name string, options v1.GetOptions) (result *v1alpha1.DatadogMetric, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(datadogmetricsResource, c.ns, name), &v1alpha1.DatadogMetric{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DatadogMetric), err
}

// List takes label and field selectors, and returns the list of DatadogMetrics that match those selectors.
func (c *FakeDatadogMetrics) List(opts v1.ListOptions) (result *v1alpha1.DatadogMetricList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(datadogmetricsResource, datadogmetricsKind, c.ns, opts), &v1alpha1.DatadogMetricList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.DatadogMetricList{ListMeta: obj.(*v1alpha1.DatadogMetricList).ListMeta}
	for _, item := range obj.(*v1alpha1.DatadogMetricList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested datadogMetrics.
func (c *FakeDatadogMetrics) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(datadogmetricsResource, c.ns, opts))

}

// Create takes the representation of a datadogMetric and creates it.  Returns the server's representation of the datadogMetric, and an error, if there is any.
func (c *FakeDatadogMetrics) Create(datadogMetric *v1alpha1.DatadogMetric) (result *v1alpha1.DatadogMetric, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(datadogmetricsResource, c.ns, datadogMetric), &v1alpha1.DatadogMetric{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DatadogMetric), err
}

// Update takes the representation of a datadogMetric and updates it. Returns the server's representation of the datadogMetric, and an error, if there is any.
func (c *FakeDatadogMetrics) Update(datadogMetric *v1alpha1.DatadogMetric) (result *v1alpha1.DatadogMetric, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(datadogmetricsResource, c.ns, datadogMetric), &v1alpha1.DatadogMetric{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DatadogMetric), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeDatadogMetrics) UpdateStatus(datadogMetric *v1alpha1.DatadogMetric) (*v1alpha1.DatadogMetric, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(datadogmetricsResource, "status", c.ns, datadogMetric), &v1alpha1.DatadogMetric{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DatadogMetric), err
}

// Delete takes name of the datadogMetric and deletes it. Returns an error if one occurs.
func (c *FakeDatadogMetrics) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(datadogmetricsResource, c.ns, name), &v1alpha1.DatadogMetric{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeDatadogMetrics) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(datadogmetricsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha1.DatadogMetricList{})
	return err
}

// Patch applies the patch and returns the patched datadogMetric.
func (c *FakeDatadogMetrics) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.DatadogMetric, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(datadogmetricsResource, c.ns, name, pt, data, subresources...), &v1alpha1.DatadogMetric{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DatadogMetric), err
}
